#ifndef __USERCONFIG_H
#define __USERCONFIG_H

#ifdef __cplusplus
extern "C" {
#endif

#include "../Public/stdpro_linux.h"
#include "../Public/Public.h"
class CUserConfig
{
public:
	CUserConfig();
	~CUserConfig();
	int 			ConfigShutdownParam(SHUTDOWNPARAM &shutdownParam);
	
private:
	int 			ClearScreen();
	void 			InitShutdownParam();
	void 			PrintNewLine();
	void 			PrintBlank(int iNum);
	void 			PrintString(char *pStr);
	void 			PrintWarning();
	void			PrintConfigTitle();
	int				ReadStdInput(char *pszBuf, int iLength);
	void 			PrintSelectMode();
	void 			ConfigSelectMode();
	void 			ConfigComPort();
	
	void			PrintACFailDelayTime();
	void			ConfigACFailDelayTime();
	
	void 			PrintExternCmd();
	void			ConfigExternCmd();
	void 			PrintExCmdNeedTime();
	void			ConfigExCmdNeedTime();
	
	void			PrintShutdownNeedTime();
	void			ConfigShutdownNeedTime();
	void			PrintSendMessage();
	void			ConfigSendMessage();
	void			PrintReconfirmInfo();
	int				ConfigReconfirm();
	void 			PrintUpsCommMode();
	void 			ConfigUpsCommMode();
	void 			ConfigShutdownMode();
	void 			PrintShutdownMode();
	void 			PrintKVMMode();
	void 			ConfigKVMMode();
	void                    PrintGuestOSMode();
	void                    ConfigGuestOSMode();
	int			JudgeSySSupportKVM();
	
private:
	char 			m_szHostName[256];
	int				m_iOSPortNo[UPS_MAX];
	SHUTDOWNPARAM 	m_ShutdownParam;
};

#ifdef __cplusplus
}
#endif

#endif
