#ifndef   __CONFIGFILE_H_
#define   __CONFIGFILE_H_

#ifdef __cplusplus
extern "C" {
#endif

#include "Public.h"

#define CONFIG_FILENAME 		AGENT_PATH"/Shutdown.cfg"
#define POWER_STATE			"/sys/power/state"

#define ShutdownParamSection	("[ShutdownParam]")
#define S_AutoMode						("AutoMode")
#define	S_PortType						("PortType")
#define S_PortNum							("PortNum")
#define S_ACFailDelayTime			("ACFailDelayTime")
#define S_ExternCmd						("ExternalCommand")
#define S_ExCmdNeedTime				("ExCmdNeedTime")
#define S_ShutdownNeedTime		("ShutdownNeedTime")
#define S_SendMsg	       			("SendMessage")
#define S_UpsCommMode				("UpsCommunicationMode")
#define S_ShutdownMode 			("Shutdown Mode")
#define S_KVMSupport			("KVM Support")
#define S_GuestOSMode			("Guest OS Mode")
#define EndSection						("[End]")
#define ENDOFLINE				0xffff

#define SELECT_MODE						AUTO_SEL
#define PORTTYPE_COM					1
#define PORTTYPE_USB					0
#define PORTTYPE_DEFAULT			PORTTYPE_COM

#define COMPORT_DEFAULT				1
#define EXTERNCMD_DEFAULT			""
#define ACFAILDELAY_DEFAULT		60
#define EXCMDNEEDTIME_DEFAULT	0            //modify 20110824
#define SDNEEDTIME_DEFAULT		180
#define SENDMSG_DEFAULT				0
#define UpsCommMode_DEFAULT			0 //Libusb
#define ShutdownMode_DEFAULT			0 //shutdown
#define KVMMode_DEFAULT					1 //ssd support kvm    modify 2011824
#define GuestOSMode_DEFAULT                         0      // shutdown mode allen20110916

#define PORTSTR_COM						("COM")
#define PORTSTR_USB						("USB")
#define PORTSTR_DEFAULT				PORTSTR_COM


#define MANUAL_SEL 	0
#define AUTO_SEL		1

class CConfigFile
{
public:
	CConfigFile();
	~CConfigFile();
	
	int 	OpenFile(char *pszFileName, char *pszMode);
	int 	CloseFile();
	
	int 	FindSection(char *pszSection);
	int 	GetString(char *pszItem, char *pszItemVal);
	int 	GetInt(char *pszItem);
	int 	TrimString(char *pszDest, char *pszStr);
	int 	GetStringFromLine (char *pszDest, char *pszBuf, UINT *nStartPos, char szSeparator);
	int 	GetStringFromString (char *pszDest, char *pszSrc, UINT *nStartPos, char szSeparator);
	int 	GetItemFromLine(char * pszBuf, char *szItem, char *szItemValue);
	
	int 	GetShutdownParameter(PSHUTDOWNPARAM pShutdownParam);
	int 	SetShutdownParameter(SHUTDOWNPARAM ShutdownParam);
	void 	SetDefaultShutdownParam(PSHUTDOWNPARAM pShutdownParam);
	
	int 	WriteOneLine (char *pszText, UINT uReturnNum);
	int 	WriteConfigurationFile();
	
private:
	FILE 			*m_pFilePointer;
	SHUTDOWNPARAM 	m_ShutdownParam;
	CPublic 	m_public;
};

#ifdef __cplusplus
}
#endif

#endif
