#ifndef __PUBLIC_H
#define __PUBLIC_H

#ifdef __cplusplus
extern "C" {
#endif

void LogOneMsg(char * strMsg);


#include "stdpro_linux.h"

#define AGENT_PATH		"/usr/lib/ssd/master"

#define BIN_FILE_AGENT		"ssdDaemon"
#define BIN_FILE_SERVICE	"ssdService"
#define PROCESS_UPSAGENT 	AGENT_PATH"/ssdDaemon"
#define PROCESS_SERVICE 	AGENT_PATH"/ssdService"

#define FIFO_KERNELTOAGENT	AGENT_PATH"/fifo.KernelToAgent"
#define FIFO_AGENTTOKERNEL	AGENT_PATH"/fifo.AgentToKernel"

#define MYFILE_MODE (S_IRUSR|S_IWUSR|S_IRGRP|S_IROTH)

#define SM_OPEN    IPC_CREAT|0700
#define SEM_OPEN   IPC_CREAT|0700
#define SEM_OPS   0

#define IPCKEY_SM_ONE			1
#define IPCKEY_SM_TWO			2
#define SEM_MAX		IPCKEY_SM_TWO + 1
#define IPCKEY_SEMS     SEM_MAX+1

#define SHM_FILE		"/etc/.SimpleShutdown"

#define FILE_MODE		(S_IRUSR | S_IWUSR | S_IXGRP | S_IXOTH)

#define LOCKFILE_AGENT 		AGENT_PATH"/Daemon.Lock"
#define LOCKFILE_SERVICE	AGENT_PATH"/Service.Lock"

#define MAX_FILE		256
#define MAX_LINELENGTH 		0x200
#define INPUT_NUM_MAX		0x200
#define MAX_EXTERNCMD_LEN	INPUT_NUM_MAX	

#define AUTOMODE_ALL_USB_WITH_COM 0x0001
#define AUTOMODE_ALL_USB_WITHOUT_COM 0x0002
#define AUTOMODE_STATIC_COM 0x0000
/* used for omrctl socket communication */
#define SOCKET_NAME "socket_omrctl"
#define UPS_STATUS_SD_OS_UPS				0x8
#define UPS_STATUS_SD_OS_RESTART_LATER		0x10
#define UPS_STATUS_ONLY_SD_OS				0x20
#define ERR_AGENTSTOP	501
#define ERR_COMLST	502
#define ERR_COMMEXEC	503
#define ERR_TIMEWRONG	504
#define WARR_REATART_TIME 505
#define ERR_OTHER	506



typedef struct _SHUTDOWNPARAM
{
	UINT	uPortType;
	UINT 	uComPort;
	UINT 	uACFailDelayTime;
	UINT	uExCmdNeedTime;
	UINT 	uShutdownNeedTime;
	char	szExternCmd[MAX_EXTERNCMD_LEN];
	int	 	iSendMsg;
	int 		iUpsCommMode; //added for UpsCommunication Mode
	int 		iShutdownMode; //added for support Hibernation
	int 		iKVMMode;
	int		AutoMode; /*willren 2009-1-15 15:48:58*/
	int             iGuestOSMode; //allen20110916
} SHUTDOWNPARAM, *PSHUTDOWNPARAM;

#define SM_DATA_LENGTH		24	
typedef struct _SHM_DATA
{
	UINT    uDataAvailable;
	UINT    uPortType;
	UINT    uPortNum;
	UINT    uAutoMode;
	DWORD   dwUPSStatus;
	UINT 	Shutdownsys;
	UINT  	RebootSys;
}SHM_DATA, * PSHM_DATA;

typedef struct tagPIPE_DATA
{
	int nCmdType;
	int nValue;
}PIPE_DATA, *PPIPE_DATA;
typedef struct tagFIFO_DATA_HEAD {
	DWORD dwCmdId;		/* Command id */
	DWORD dwDataLen; 	/* The length of data, not including this header */
	DWORD dwSysComID;	/* The index id zero-based, if the highest bit is 1, all ups implement same action */
	DWORD dwParam;		/* The reserved parameter */
	DWORD dwReserved;	/* The reserved */
} FIFO_DATA_HEAD, *PFIFO_DATA_HEAD;

/* the struct of socket communication */
typedef struct _SOCKET_DATA_OMRON{
	UINT uCmd;
	UINT uPara1;
	UINT uPara2;
	UINT uPara3;
	UINT uPara4;
}SOCKET_DATA_OMRON;

/* used for socket communication */
#define MAXLINE 80
#define SERV_PORT 8011





#define RESPONSE_SN			0
#define REQUEST_SN			1

#define READ_MODE			0
#define WRITE_MODE			1

#define MAX_FIFODATA_LEN		64

enum PortType {USB, COM};
enum UpsComm{LIBUSB, HID};

class CPublic
{
public:
	CPublic();
	~CPublic();
	
	int 	SetLock(char *pszLockFile);
	int 	CheckLock(char *pszLockFile);
	int 	UnsetLock(int ifd, char *pszLockFile);
	void 	DelayInUsec(int sec, int usecond);
	int 	CreateDaemon();
	int 	IsServiceActive(char *pszLockFile);
	int 	System(char *pszCmd);

	int		OpenFifo(char *pchFifoName, int nMode); /*nMode  return fifo id , -1 error*/
	int		ReadFIFOData(int readfifofd, PPIPE_DATA pipeData);
	int 	SendFIFOData(int writefifofd, PPIPE_DATA pipeData);
	int		CloseFifo(int nFifoId); /*if nEnd , del fifo file */
	int		UnlinkFifo(char *pchFifoName);

	int		PA2_rename(char* old_file_name, char* new_file_name);

	int		 GetSize(int iIPCKey);
	int		GetIPCkey(int key);
	int		CheckIsExist(int iIPCKey);
	int		CreateSM(int iIPCKey, int size_val);
	int		DestorySM(int iIPCKey);

	void*	GetSMData(int iIPCKey,int* ilen);
	int		SetSMData(int iIPCKey,void * param, int paramlen);

	int		InitSems();
	int		GetSemsID();
	int		CreateSems();

	int		WaitSem(int index);
	int		PostSem(int index);

	int		WaitSemX(int idSem,int index,short flag);
	int		PostSemX(int idSem,int index,short flag);
	void		DestorySem(int idSem);

	int 		serv_accept(int listenfd);
	int 		serv_create();
	int 		cli_conn();
	int 		Accept(int fd, struct sockaddr *sa, socklen_t *salenptr);
	int 		Socket(int family, int type, int protocol);
	void 	Listen(int fd, int backlog);
	int 		Connect(int fd, const struct sockaddr *sa, socklen_t salen);
	void 	Bind(int fd, const struct sockaddr *sa, socklen_t salen);
	int 		Read(int fd, void *ptr, size_t nbytes);
	int 		Write(int fd, const void *ptr, size_t nbytes);
	void 	Close(int fd);
	void		perr_exit(const char *s);
};

#ifdef __cplusplus
}
#endif

#endif
