#ifndef __UPSAGENT_H
#define __UPSAGENT_H

#ifdef __cplusplus
extern "C" {
#endif

#include "../Public/ups.h"
#include "../Public/Event.h"
#include "../Public/ConfigFile.h"
#include "../Public/Public.h"

class CUPSAgent
{
public:
	CUPSAgent();
	~CUPSAgent();

	int			Initialize();
	int			ScanPort();
	void			Terminate();
	static void		sig_usr(int sig);
	int 			ReadSocket(int socketfd, int iConnect);
	int 	ClearReadValue();
	
	static CUPSAgent *m_pThis;
	
	int Commandexec; // Record whether have ordered are running
	
private:
	int			m_iRunAgent;
	UINT			m_uCommPort;
	DWORD			m_dwUPSStatus;
	int			m_iACFail;
	time_t			m_tACFailStart;
	CUPS			m_ups;
	CPublic			m_public;
	CConfigFile		m_cfg;
	CEvent			m_event;
	int 			socketfd;
	
	int			m_writefifofd;
	int			m_writefifoTmp;
	int			m_readfifofd;
	int 			iConnect;
	
	PIPE_DATA		m_RecvPipe;
	PIPE_DATA		m_SendPipe;
	SHM_DATA		m_SHMData;
	
	SHUTDOWNPARAM		m_AutoSDParam;
	SOCKET_DATA_OMRON 	Socketdata;
	
	int			m_iAutoPort;
	int 		kvm_support;
};

#ifdef __cplusplus
}
#endif

#endif
