#include "main.h"

CAgent* CAgent::m_pThis = NULL;

CAgent::CAgent()
{
	m_pThis = this;
}

CAgent::~CAgent()
{
}
	
void CAgent::sighandler(int signum)
{
	int	status;

	if(signum == SIGCHLD)
	{
		wait(&status);
	}
		
	if(signum == SIGUSR1)
	{
		m_pThis->m_upsAgent.Terminate();
	}
}

int CAgent::Initialize()
{
	if (m_public.IsServiceActive(LOCKFILE_AGENT))
		return 0;

	if (m_public.CreateDaemon())
		return 0;
	
	if ((m_iFileLock = m_public.SetLock(LOCKFILE_AGENT)) == -1)
		return 0;

	m_upsAgent.Initialize();
	
	signal(SIGCHLD, m_pThis->sighandler);
	signal(SIGUSR1, m_pThis->sighandler);
	return 1;
}

void CAgent::Run()
{
	sleep(8);
	m_upsAgent.ScanPort();

	m_public.UnsetLock(m_iFileLock, LOCKFILE_AGENT);
	unlink(LOCKFILE_AGENT);
}

int main(int argc, char **argv)
{
	CAgent Agent;
	CPublic pub;
	
	if (!pub.CheckLock(LOCKFILE_SERVICE))
	{
		printf("Warning: The process ssdService is not running, please start it firstly.\n");
		printf("         To start ssdService please run command:\n");
		printf("         /usr/lib/ssd/master/AgentManager\n");
		return -1;
	}
	
	if (Agent.Initialize() > 0)
		Agent.Run();
	
	return 0;
}
